diff --git a/tests/test_flask.py b/tests/test_flask.py
index 38cb7d7..264c9cb 100644
--- a/tests/test_flask.py
+++ b/tests/test_flask.py
@@ -1762,13 +1875,14 @@ class Flasktests(Modeltests):
             output = self.app.post('/meeting/edit/1/', data=data,
                                    follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>test_calendar_disabled - Fedocal</title>'
-                in output.data)
-            self.assertTrue(
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>test_calendar_disabled - Fedocal</title>',
+                output_text)
+            self.assertIn(
                 '<li class="errors">This calendar is &#34;Disabled&#34;, '
-                'you are not allowed to add meetings to it anymore.</li>'
-                in output.data)
+                'you are not allowed to add meetings to it anymore.</li>',
+                output_text)
 
         # Add a meeting to the test_calendar_disabled calendar
         obj = model.Meeting(  # id:16
@@ -1802,13 +1916,14 @@ class Flasktests(Modeltests):
             output = self.app.post('/meeting/edit/16/', data=data,
                                    follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>test_calendar_disabled - Fedocal</title>'
-                in output.data)
-            self.assertTrue(
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>test_calendar_disabled - Fedocal</title>',
+                output_text)
+            self.assertIn(
                 '<li class="errors">This calendar is &#34;Disabled&#34;, '
-                'you are not allowed to edit its meetings anymore.</li>'
-                in output.data)
+                'you are not allowed to edit its meetings anymore.</li>',
+                output_text)
 
         user = FakeUser(['packager'], username='pingou')
         with user_set(fedocal.APP, user):
@@ -1816,35 +1931,35 @@ class Flasktests(Modeltests):
             output = self.app.get(
                 '/meeting/edit/12/?from_date=foor', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>Edit meeting - Fedocal</title>' in output.data)
-            self.assertTrue(
-                '<h2>Edit meeting "Another past test meeting"</h2>'
-                in output.data)
-            self.assertTrue(
-                'meeting_name">Meeting name</label>'
-                in output.data)
-            self.assertTrue(
-                'for="meeting_date">Date</label>'
-                in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>Edit meeting - Fedocal</title>', output_text)
+            self.assertIn(
+                '<h2>Edit meeting "Another past test meeting"</h2>',
+                output_text)
+            self.assertIn(
+                'meeting_name">Meeting name</label>', output_text)
+            self.assertIn(
+                'for="meeting_date">Date</label>', output_text)
             self.assertEqual(
-                output.data.count('<span class="required">*</span>'), 6)
+                output_text.count('<span class="required">*</span>'), 6)
 
             output = self.app.get(
                 '/meeting/edit/12/?from_date=%s' % TODAY.strftime('%Y-%m-%d'),
                 follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>Edit meeting - Fedocal</title>' in output.data)
-            self.assertTrue(
-                '<h2>Edit meeting "Another past test meeting"</h2>'
-                in output.data)
-            self.assertTrue(
-                'meeting_name">Meeting name</label' in output.data)
-            self.assertTrue(
-                'for="meeting_date">Date</label>' in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>Edit meeting - Fedocal</title>', output_text)
+            self.assertIn(
+                '<h2>Edit meeting "Another past test meeting"</h2>',
+                output_text)
+            self.assertIn(
+                'meeting_name">Meeting name</label', output_text)
+            self.assertIn(
+                'for="meeting_date">Date</label>', output_text)
             self.assertEqual(
-                output.data.count('<span class="required">*</span>'), 6)
+                output_text.count('<span class="required">*</span>'), 6)
 
     @flask10_only
     def test_delete_meeting(self):
@@ -1854,70 +1969,75 @@ class Flasktests(Modeltests):
         with user_set(fedocal.APP, user):
             output = self.app.get('/meeting/delete/50/', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '"errors">No meeting with this identifier could be found.</'
-                in output.data)
-            self.assertTrue('<title>Home - Fedocal</title>' in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '"errors">No meeting with this identifier could be found.</',
+                output_text)
+            self.assertIn('<title>Home - Fedocal</title>', output_text)
 
             output = self.app.get('/meeting/delete/1/', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
                 '<li class="errors">You are not one of the manager of this '
-                'meeting, or an admin, you are not allowed to delete it.</l'
-                in output.data)
-            self.assertTrue(
-                '<title>Meeting "Fedora-fr-test-meeting" - Fedocal</title>'
-                in output.data)
+                'meeting, or an admin, you are not allowed to delete it.</l',
+                output_text)
+            self.assertIn(
+                '<title>Meeting "Fedora-fr-test-meeting" - Fedocal</title>',
+                output_text)
 
         user = FakeUser(['fi-apprentice'], username='kevin')
         with user_set(fedocal.APP, user):
             output = self.app.get('/meeting/delete/1/', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
                 '<li class="errors">You are not one of the manager of this '
-                'meeting, or an admin, you are not allowed to delete it.</l'
-                in output.data)
-            self.assertTrue(
-                '<title>Meeting "Fedora-fr-test-meeting" - Fedocal</title>'
-                in output.data)
+                'meeting, or an admin, you are not allowed to delete it.</l',
+                output_text)
+            self.assertIn(
+                '<title>Meeting "Fedora-fr-test-meeting" - Fedocal</title>',
+                output_text)
 
         user = FakeUser(['fi-apprentice'], username='pingou')
         with user_set(fedocal.APP, user):
             output = self.app.get('/meeting/delete/1/')
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>Delete meeting - Fedocal</title>' in output.data)
-            self.assertTrue(
-                '<h4>Meeting: Fedora-fr-test-meeting</h4>'
-                in output.data)
-            self.assertTrue(
-                "positively sure that's what you want to do?"
-                in output.data)
-            self.assertTrue(
-                'name="confirm_delete" type="checkbox" value="y"><label'
-                in output.data)
-            self.assertTrue(
-                '<input id="confirm_button" type="submit" class="submit positi'
-                in output.data)
-
-            csrf_token = output.data.split(
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>Delete meeting - Fedocal</title>', output_text)
+            self.assertIn(
+                '<h4>Meeting: Fedora-fr-test-meeting</h4>',
+                output_text)
+            self.assertIn(
+                "positively sure that's what you want to do?",
+                output_text)
+            self.assertIn(
+                'name="confirm_delete" type="checkbox" value="y"><label',
+                output_text)
+            self.assertIn(
+                '<input id="confirm_button" type="submit" class="submit positi',
+                output_text)
+
+            csrf_token = output_text.split(
                 'name="csrf_token" type="hidden" value="')[1].split('">')[0]
 
             # Invalid from_date
             output = self.app.get(
                 '/meeting/delete/1/?from_date=foobar', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>Delete meeting - Fedocal</title>' in output.data)
-            self.assertTrue(
-                '<h4>Meeting: Fedora-fr-test-meeting</h4>'
-                in output.data)
-            self.assertTrue(
-                "positively sure that's what you want to do?"
-                in output.data)
-            self.assertTrue(
-                'name="confirm_delete" type="checkbox" value="y"><label'
-                in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>Delete meeting - Fedocal</title>', output_text)
+            self.assertIn(
+                '<h4>Meeting: Fedora-fr-test-meeting</h4>',
+                output_text)
+            self.assertIn(
+                "positively sure that's what you want to do?",
+                output_text)
+            self.assertIn(
+                'name="confirm_delete" type="checkbox" value="y"><label',
+                output_text)
 
             # Do not delete
             data = {
@@ -1928,8 +2048,9 @@ class Flasktests(Modeltests):
             output = self.app.post('/meeting/delete/1/', data=data,
                                    follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>test_calendar - Fedocal</title>' in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>test_calendar - Fedocal</title>', output_text)
 
             # Delete
             data = {
@@ -1940,10 +2061,11 @@ class Flasktests(Modeltests):
             output = self.app.post('/meeting/delete/1/', data=data,
                                    follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>test_calendar - Fedocal</title>' in output.data)
-            self.assertTrue(
-                '<li class="message">Meeting deleted</li>' in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>test_calendar - Fedocal</title>', output_text)
+            self.assertIn(
+                '<li class="message">Meeting deleted</li>', output_text)
 
             # Delete all
             data = {
@@ -1955,10 +2077,11 @@ class Flasktests(Modeltests):
             output = self.app.post('/meeting/delete/8/', data=data,
                                    follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>test_calendar - Fedocal</title>' in output.data)
-            self.assertTrue(
-                '<li class="message">Meeting deleted</li>' in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>test_calendar - Fedocal</title>', output_text)
+            self.assertIn(
+                '<li class="message">Meeting deleted</li>', output_text)
 
         # Add a meeting to the test_calendar_disabled calendar
         obj = model.Meeting(  # id:16
@@ -1987,13 +2110,14 @@ class Flasktests(Modeltests):
             output = self.app.post('/meeting/delete/16/', data=data,
                                    follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<title>test_calendar_disabled - Fedocal</title>'
-                in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>test_calendar_disabled - Fedocal</title>',
+                output_text)
             self.assertTrue(
                 '<li class="errors">This calendar is &#34;Disabled&#34;, '
-                'you are not allowed to delete its meetings anymore.</li>'
-                in output.data)
+                'you are not allowed to delete its meetings anymore.</li>',
+                output_text)
 
     def test_update_tz(self):
         """ Test the update_tz function. """
@@ -2001,15 +2125,18 @@ class Flasktests(Modeltests):
 
         output = self.app.get('/updatetz/?tzone=Europe/Paris',
                               follow_redirects=True)
-        self.assertTrue('<title>Home - Fedocal</title>' in output.data)
-        self.assertTrue('<li class="warnings">Invalid referred url</li>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn('<title>Home - Fedocal</title>', output_text)
+        self.assertIn(
+            '<li class="warnings">Invalid referred url</li>', output_text)
 
         output = self.app.get('/updatetz/',
                               follow_redirects=True)
-        self.assertTrue('<title>Home - Fedocal</title>' in output.data)
-        self.assertTrue('<li class="warnings">Invalid referred url</li>'
-                        in output.data)
+        self.assertIn('<title>Home - Fedocal</title>', output_text)
+        self.assertIn(
+            '<li class="warnings">Invalid referred url</li>',
+            output_text)
 
     def test_search(self):
         """ Test the search function. """
@@ -2018,29 +2145,39 @@ class Flasktests(Modeltests):
         # With '*'
         output = self.app.get('/search/?keyword=*meeting3*',
                               follow_redirects=True)
-        self.assertTrue('<title>Search - Fedocal</title>' in output.data)
-        self.assertTrue('<p>Result of your search for "*meeting3*"</p>'
-                        in output.data)
-        self.assertTrue('href="/meeting/4/?from_date='in output.data)
-        self.assertTrue('<p>Test meeting with past end_recursion....</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn('<title>Search - Fedocal</title>', output_text)
+        self.assertIn(
+            '<p>Result of your search for "*meeting3*"</p>',
+            output_text)
+        self.assertIn('href="/meeting/4/?from_date=', output_text)
+        self.assertIn(
+            '<p>Test meeting with past end_recursion....</p>',
+            output_text)
 
         # Without any '*'
         output = self.app.get('/search/?keyword=meeting3',
                               follow_redirects=True)
-        self.assertTrue('<title>Search - Fedocal</title>' in output.data)
-        self.assertTrue('<p>Result of your search for "meeting3*"</p>'
-                        in output.data)
-        self.assertFalse('href="/meeting/4/?from_date='in output.data)
-        self.assertFalse('href="/meeting/4/'in output.data)
-        self.assertFalse('d> <p>Test meeting with past end_recursion.</p> </'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn('<title>Search - Fedocal</title>', output_text)
+        self.assertIn(
+            '<p>Result of your search for "meeting3*"</p>', output_text)
+        self.assertNotIn('href="/meeting/4/?from_date=', output_text)
+        self.assertNotIn('href="/meeting/4/', output_text)
+        self.assertNotIn(
+            'd> <p>Test meeting with past end_recursion.</p> </',
+            output_text)
 
         output = self.app.get('/search/',
                               follow_redirects=True)
-        self.assertTrue('<title>Home - Fedocal</title>')
-        self.assertTrue('class="errors">No keyword provided for the search</'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn('<title>Home - Fedocal</title>', output_text)
+        self.assertIn(
+            'class="errors">No keyword provided for the search</',
+            output_text)
 
     def test_goto(self):
         """ Test the goto function. """
@@ -2055,90 +2192,113 @@ class Flasktests(Modeltests):
         }
 
         output = self.app.get('/goto/', follow_redirects=True)
-        self.assertTrue('<title>Home - Fedocal</title>' in output.data)
-        self.assertTrue('<li class="errors">No calendar specified</li>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn('<title>Home - Fedocal</title>', output_text)
+        self.assertIn(
+            '<li class="errors">No calendar specified</li>', output_text)
 
         output = self.app.get('/goto/?calendar=test_calendar',
                               follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get('/goto/?calendar=test_calendar&month=3',
                               follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get('/goto/?calendar=test_calendar&month=3&day=1',
                               follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get(
             '/goto/?calendar=test_calendar&year=2010&month=3&day=1',
             follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get(
             '/goto/?calendar=test_calendar&year=2010&month=3&day=a',
             follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<li class="errors">Invalid date specified</li>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<li class="errors">Invalid date specified</li>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get(
             '/goto/?calendar=test_calendar&year=2010&month=a',
             follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<li class="errors">Invalid date specified</li>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<li class="errors">Invalid date specified</li>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get('/goto/?calendar=test_calendar&year=a',
                               follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<li class="errors">Invalid date specified</li>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<li class="errors">Invalid date specified</li>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get('/goto/?calendar=test_calendar&year=1870',
                               follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('="warnings">Dates before 1900 are not allowed</li'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '="warnings">Dates before 1900 are not allowed</li',
+            output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get('/goto/?calendar=test_calendar&type=list',
                               follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
         output = self.app.get('/goto/?calendar=test_calendar&type=foobar',
                               follow_redirects=True)
-        self.assertTrue('<title>test_calendar - Fedocal</title>'
-                        in output.data)
-        self.assertTrue('<p>This is a test calendar</p>'
-                        in output.data)
+        self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
+        self.assertIn(
+            '<title>test_calendar - Fedocal</title>', output_text)
+        self.assertIn(
+            '<p>This is a test calendar</p>', output_text)
 
     @flask10_only
     def test_upload_calendar(self):
@@ -2150,69 +2310,77 @@ class Flasktests(Modeltests):
             output = self.app.get('/calendar/upload/1/',
                                   follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
-                '<li class="errors">No calendar named 1 could be found</li'
-                in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<li class="errors">No calendar named 1 could be found</li',
+                output_text)
 
             output = self.app.get('/calendar/upload/test_calendar/',
                                   follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue(
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
                 '<li class="errors">You are not an admin for this calendar, '
-                'you are not allowed to upload a iCalendar file to it.</l'
-                in output.data)
-            self.assertTrue(
-                '<title>Home - Fedocal</title>'
-                in output.data)
+                'you are not allowed to upload a iCalendar file to it.</l',
+                output_text)
+            self.assertIn(
+                '<title>Home - Fedocal</title>', output_text)
 
         user = FakeUser(['packager'], username='kevin')
         with user_set(fedocal.APP, user):
             output = self.app.get('/calendar/upload/test_calendar/',
                                   follow_redirects=True)
             self.assertEqual(output.status_code, 200)
-            self.assertTrue('<title>Upload calendar - Fedocal</title>'
-                            in output.data)
-            self.assertTrue('<h2>Upload calendar</h2>' in output.data)
+            output_text = output.get_data(as_text=True)
+            self.assertIn(
+                '<title>Upload calendar - Fedocal</title>', output_text)
+            self.assertIn('<h2>Upload calendar</h2>', output_text)
 
-            csrf_token = output.data.split(
+            csrf_token = output_text.split(
                 'name="csrf_token" type="hidden" value="')[1].split('">')[0]
 
-            with open(ICS_FILE) as stream:
+            with open(ICS_FILE, 'rb') as stream:
                 data = {
                     'ics_file': stream,
+                    'enctype': 'multipart/form-data',
                     'csrf_token': csrf_token,
                 }
                 output = self.app.post('/calendar/upload/test_calendar/',
                                        follow_redirects=True, data=data)
                 self.assertEqual(output.status_code, 200)
-                if '<li class="error">' not in output.data:
-                    self.assertTrue('<title>test_calendar - Fedocal</title>'
-                                    in output.data)
-                    self.assertTrue('<p>This is a test calendar</p>'
-                                    in output.data)
-                    self.assertTrue(
-                        'li class="message">Calendar uploaded</li>'
-                        in output.data)
+                output_text = output.get_data(as_text=True)
+                if '<li class="error">' not in output_text:
+                    self.assertIn(
+                        '<title>test_calendar - Fedocal</title>',
+                        output_text)
+                    self.assertIn(
+                        '<p>This is a test calendar</p>', output_text)
+                    self.assertIn(
+                        'li class="message">Calendar uploaded</li>',
+                        output_text)
                 else:
-                    self.assertTrue(
+                    self.assertIn(
                         '<li class="error">The submitted candidate has the '
                         'MIME type &#34;application/octet-stream&#34; which '
-                        'is not an allowed MIME type</li>' in output.data)
+                        'is not an allowed MIME type</li>', output_text)
 
-            with open(ICS_FILE_NOTOK) as stream:
+            with open(ICS_FILE_NOTOK, 'rb') as stream:
                 data = {
                     'ics_file': stream,
+                    'enctype': 'multipart/form-data',
                     'csrf_token': csrf_token,
                 }
                 output = self.app.post('/calendar/upload/test_calendar/',
                                        follow_redirects=True, data=data)
                 self.assertEqual(output.status_code, 200)
-                self.assertTrue('<title>Upload calendar - Fedocal</title>'
-                                in output.data)
-                self.assertTrue('<li class="error">The submitted candidate '
-                                'has the file extension &#34;txt&#34; which is'
-                                ' not an allowed format</li>'
-                                in output.data)
+                output_text = output.get_data(as_text=True)
+                self.assertIn(
+                    '<title>Upload calendar - Fedocal</title>',
+                    output_text)
+                self.assertIn(
+                    '<li class="error">The submitted candidate has the file '
+                    'extension &#34;txt&#34; which is not an allowed '
+                    'format</li>', output_text)
 
     @flask10_only
     def test_markdown_preview(self):
@@ -2227,7 +2395,8 @@ class Flasktests(Modeltests):
             }
             output = self.app.post('/markdown/', data=data)
             self.assertEqual(output.status_code, 200)
-            self.assertEqual(output.data, ' <p><code>test</code></p> ')
+            output_text = output.get_data(as_text=True)
+            self.assertEqual(output_text, ' <p><code>test</code></p> ')
 
 
 if __name__ == '__main__':
